import xbmc, xbmcaddon, xbmcgui, xbmcplugin, os, base64, sys, xbmcvfs
import shutil
import urllib2, urllib
import re
import extract
import downloader
import time
import plugintools
from addon.common.addon import Addon
from addon.common.net import Net




USER_AGENT 			= 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3'
addon_id 			= 'plugin.video.apk.downloader'
ADDON 				= xbmcaddon.Addon(id=addon_id)
AddonTitle			= "APK Downloader"
dialog				= xbmcgui.Dialog()
net 				= Net()
AddonTitle3 		        = "APK Downloader FILE CLEANER"
U 			        = ADDON.getSetting('User')
FANART 				= xbmc.translatePath(os.path.join('special://home/addons/' + addon_id , 'fanart.jpg'))
FANART1 			= xbmc.translatePath(os.path.join('special://home/addons/' + addon_id , 'resources/art/fanart/fanart1.jpg'))
FANART2 			= xbmc.translatePath(os.path.join('special://home/addons/' + addon_id , 'resources/art/fanart/fanart2.jpg'))
FANART3 			= xbmc.translatePath(os.path.join('special://home/addons/' + addon_id , 'resources/art/fanart/fanart3.jpg'))
FANART_EMULATORS                = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id , 'resources/art/emulators.png'))
ICON 				= xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'icon1.png'))
ART 				= xbmc.translatePath(os.path.join('special://home/addons/' + addon_id + '/resources/art/android/'))
ART1 				= xbmc.translatePath(os.path.join('special://home/addons/' + addon_id + '/resources/art/windows/'))
ART2 				= xbmc.translatePath(os.path.join('special://home/addons/' + addon_id + '/resources/art/linux/'))
VERSION 			= "0.0.1"
DBPATH 				= xbmc.translatePath('special://database')
TNPATH 				= xbmc.translatePath('special://thumbnails');
PATH 				= "Kobra Wizard"            
BASEURL			        = "http://kodicustombuilds.com/builds"
BASEURL1 			= "http://kodicustombuilds.com/builds"
BASEURL2 			= "http://kodicustombuilds.com/test"
HOME 				= xbmc.translatePath('special://home/')
ADDONS 				= os.path.join(HOME,     'addons')
PACKAGES 			= os.path.join(ADDONS,   'packages')
H 			        = 'http://' 

#################
##### INTRO #####
#################

def INTRO():
    xbmc.executebuiltin( "PlayMedia(special://home/addons/plugin.video.apk.downloader/resources/intro/1KODI-intro-video.mp4)" )
    xbmc.sleep(6000)
    INDEX1()


#################
#### INDEX 1 ####
#################

def INDEX1():
    if xbmc.getCondVisibility("System.Platform.Android"):
       addDir('ANDROID',BASEURL,2,ART+'android3.png',FANART,'')
    if xbmc.getCondVisibility("System.Platform.Windows"):   
       addDir('WINDOWS',BASEURL,12,ART1+'windows3.png',FANART1,'')
    if xbmc.getCondVisibility("System.Platform.Linux"):
       addDir('LINUX',BASEURL,97,ART2+'linux3.png',FANART2,'')
    addDir('REQUESTS',BASEURL,13,ART+'requests.png',FANART3,'')
    setView('list', 'MAIN')


######################
#### ANDROID MENU ####
######################

def BUILDMENU():
    addDir('JAYTECHS APPS',BASEURL,6,ART+'apps.png',FANART,'')
    addDir('EMULATORS',BASEURL,7,ART+'emulators.png',FANART,'')
    addDir('ROMS',BASEURL,99,ART+'roms.png',FANART,'')
    addDir('MURDOCS APPS',BASEURL,9,ART+'adult.png',FANART,'')
    setView('list', 'MAIN')
	
# NEXT UPDATE #
#def BUILDMENU():
   # addDir('APPLICATIONS',BASEURL,6,ART+'applications3.png',FANART,'')
   # addDir('EMULATORS',BASEURL,7,ART+'emulators3.png',FANART,'')
   # addDir('ROMS',BASEURL,99,ART+'roms3.png',FANART,'')
   # addDir('MOVIES, TV & SPORT',BASEURL,99,ART+'moviestvandsport3.png',FANART,'')
   # addDir('MUSIC',BASEURL,99,ART+'music3.png',FANART,'')
   # addDir('GAMES',BASEURL,99,ART+'games3.png',FANART,'')
   # addDir('MURDOCS APPS',BASEURL,9,ART+'adult3.png',FANART,'')
    #setView('list', 'MAIN')

	
######################
#### WINDOWS MENU ####
######################
		
def BUILDMENU1():
    addDir('PROGRAMS',BASEURL,98,ART1+'programs.png',FANART,'')
    addDir('ISOs',BASEURL,98,ART1+'isos.png',FANART,'')
    setView('list', 'MAIN')
	
		
#########################
### JAYTECHS APPS URL ###
#########################

def APPSWIZARD():
    link = OPEN_URL('https://www.dropbox.com/s/82jyzzmzseb45l7/apk.downloader.apps.wizard.txt?dl=1').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir(name,url,5,iconimage,fanart,description)
    setView('list', 'MAIN')
	
	
########################
### MURDOCS APPS URL ###
########################

def APPSWIZARD1():
    link = OPEN_URL('https://www.dropbox.com/s/rljxwedorf24pts/apk.downloader.apps.murdoc.wizard.txt?dl=1').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir(name,url,10,iconimage,fanart,description)
    setView('list', 'MAIN')

	
#####################
### EMULATORS URL ###
#####################

def EMULATORWIZARD():
    link = OPEN_URL('https://www.dropbox.com/s/gc354zpbdkc3jtq/apk.downloader.apps.emulators.wizard.txt?dl=1').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir(name,url,8,iconimage,fanart,description)
    setView('list', 'MAIN')
	

#################################
####### POPUP TEXT BOXES ########
#################################

def TextBoxes(heading,announce):
  class TextBox():
    WINDOW=10147
    CONTROL_LABEL=1
    CONTROL_TEXTBOX=5
    def __init__(self,*args,**kwargs):
      xbmc.executebuiltin("ActivateWindow(%d)" % (self.WINDOW, )) # activate the text viewer window
      self.win=xbmcgui.Window(self.WINDOW) # get window
      xbmc.sleep(500) # give window time to initialize
      self.setControls()
    def setControls(self):
      self.win.getControl(self.CONTROL_LABEL).setLabel(heading) # set heading
      try: f=open(announce); text=f.read()
      except: text=announce
      self.win.getControl(self.CONTROL_TEXTBOX).setText(str(text))
      return
  TextBox()   
    
  
############################
#### APPS INSTALL ##########
############################
# THANKS TO ][NT3L][G3NC][ #
############################

def APPINSTALL(name,url,description):
   confirm=xbmcgui.Dialog()
   if confirm.yesno(name,description,"","","GO BACK","DOWNLOAD"):
    downloadpath = xbmc.translatePath(os.path.join('special://home/addons','packages'))
    dp = xbmcgui.DialogProgress()
    dp.create("The APK Downloader Is","DOWNLOADING...",name,'PLEASE WAIT...')
    lib=os.path.join(downloadpath, name+'.apk')
    downloader.download(url, lib, dp)
    addonfolder = xbmc.translatePath(os.path.join('special://','home'))
    dialog = xbmcgui.Dialog()
    dialog.ok("APK Downloader ","DOWNLOAD COMPLETE.","","CLICK OK TO INSTALL " + name + "")
	#][NT3L]I[G3NC][# 
    xbmc.executebuiltin('StartAndroidActivity("","android.intent.action.VIEW","application/vnd.android.package-archive","file:'+lib+'")')
    time.sleep(4)
    CLEANUP()
    dialog.ok("APK DOWNLOADER AND INSTALLER"," "," ","THANKS FOR USING THE APK DOWNLOADER AND INSTALLER BY A1 MEDIA")
    try: os.remove(lib)
    except: pass

	
#########################
### EMULATOR INSTALL ####
#########################

def EMULATORINSTALL(name,url,description):
   confirm=xbmcgui.Dialog()
   if confirm.yesno(name,description,"","","GO BACK","DOWNLOAD"):
    downloadpath = xbmc.translatePath(os.path.join('special://home/addons','packages'))#
    dp = xbmcgui.DialogProgress()
    dp.create("A1 MEDIA ADULT APP INSTALLER","DOWNLOADING...",name,'PLEASE WAIT...')
    lib=os.path.join(downloadpath, name+'.apk')
    downloader.download(url, lib, dp)
    addonfolder = xbmc.translatePath(os.path.join('special://','home'))
    dialog = xbmcgui.Dialog()
    dialog.ok("A1 MEDIA EMULATOR INSTALLER","DOWNLOAD COMPLETE.","","CLICK OK TO INSTALL " + name + "")
	#][NT3L]I[G3NC][# 
    xbmc.executebuiltin('StartAndroidActivity("","android.intent.action.VIEW","application/vnd.android.package-archive","file:'+lib+'")')
    time.sleep(4)
    CLEANUP()
    dialog.ok("A1 MEDIA EMULATOR INSTALLER"," "," ","THANKS FOR USING A1 MEDIA EMULATOR INSTALLER")
    try: os.remove(lib)
    except: pass
	
##########################
### ADULT APP INSTALL ####
##########################

def ADULTINSTALL(name,url,description):
   confirm=xbmcgui.Dialog()
   if confirm.yesno(name,description,"","","GO BACK","DOWNLOAD"):
    downloadpath = xbmc.translatePath(os.path.join('special://home/addons','packages'))#
    dp = xbmcgui.DialogProgress()
    dp.create("A1 MEDIA ADULT APP INSTALLER","DOWNLOADING...",name,'PLEASE WAIT...')
    lib=os.path.join(downloadpath, name+'.apk')
    downloader.download(url, lib, dp)
    addonfolder = xbmc.translatePath(os.path.join('special://','home'))
    dialog = xbmcgui.Dialog()
    dialog.ok("A1 MEDIA ADULT APP INSTALLER","DOWNLOAD COMPLETE.","","CLICK OK TO INSTALL " + name + "")
	#][NT3L]I[G3NC][# 
    xbmc.executebuiltin('StartAndroidActivity("","android.intent.action.VIEW","application/vnd.android.package-archive","file:'+lib+'")')
    time.sleep(4)
    CLEANUP()
    dialog.ok("A1 MEDIA ADULT APP INSTALLER"," "," ","THANKS FOR USING A1 MEDIA ADULT APP INSTALLER")
    try: os.remove(lib)
    except: pass
	
################################
###### CLEAN UP PACKAGES #######
##### THANKS GUYS @ XUNITY ##### 
##### MODDED BY AFTERMATH ######
################################
		
def CLEANUP():
	if os.path.exists(PACKAGES):
		try:	
			for root, dirs, files in os.walk(PACKAGES):
				file_count = 0
				file_count += len(files)
				# Count files and give option to delete
				if file_count > 0:
					if dialog.yesno("A1 MEDIA FILE CLEANER", str(file_count) + " FILES FOUND","","WOULD YOU LIKE TO DELETE THE PACKAGE FILES?", nolabel='NO, CANCEL',yeslabel='YES, DELETE'):
						for f in files:	os.unlink(os.path.join(root, f))
						for d in dirs: shutil.rmtree(os.path.join(root, d))
						dialog.ok(AddonTitle3,'CLEAN UP FILES: [COLOR green] SUCCESS[/COLOR]!')
				else: dialog.ok(AddonTitle3,'CLEAN UP FILES: [COLOR red]NONE FOUND[/COLOR]!')
		except: dialog.ok(AddonTitle3,'CLEAN UP FILES: [COLOR red] ERROR[/COLOR]!')
	else: dialog.ok(AddonTitle3,'CLEAN UP FILES: [COLOR red] NONE FOUND[/COLOR]!')
	
	
################
### REQUESTS ###
################

def REQUESTS():
    dialog.ok("A1 MEDIA APP INSTALLER","[COLOR grey]PLEASE SEND ANY PACKAGE REQUESTS TO:[/COLOR]","[COLOR dodgerblue]FACEBOOK: https://www.facebook.com/groups/a1media/ [/COLOR]","[COLOR dodgerblue]FACEBOOK: https://www.facebook.com/profile.php?id=100011845114961[/COLOR]")

   
def OPEN_URL(url):
    req = urllib2.Request(url)
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
    response = urllib2.urlopen(req)
    link=response.read()
    response.close()
    return link


###################
### COMING SOON ###
###################
	
def COMINGSOONWINDOWS():
    addDir('COMING SOON...',BASEURL,0,ART1+'comingsoon4.png',FANART1,'')
    setView('movies', 'MAIN')
	
def COMINGSOONANDROID():
    addDir('COMING SOON...',BASEURL,0,ART+'comingsoon3.png',FANART,'')
    setView('movies', 'MAIN')

def COMINGSOONLINUX():
    addDir('COMING SOON...',BASEURL,0,ART2+'comingsoon5.png',FANART2,'')
    setView('movies', 'MAIN')

  
def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param

N = base64.decodestring('')
T = base64.decodestring('L2FkZG9ucy50eHQ=')
B = base64.decodestring('')
F = base64.decodestring('')
def addDir(name,url,mode,iconimage,fanart,description):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)+"&fanart="+urllib.quote_plus(fanart)+"&description="+urllib.quote_plus(description)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name, "Plot": description } )
        liz.setProperty( "Fanart_Image", fanart )
        if mode==5 or mode==8  or mode==10 or mode==11 or mode==13:
            ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        else:
            ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
        return ok

        
                      
params=get_params()
url=None
name=None
mode=None
iconimage=None
fanart=None
description=None


try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        iconimage=urllib.unquote_plus(params["iconimage"])
except:
        pass
try:        
        mode=int(params["mode"])
except:
        pass
try:        
        fanart=urllib.unquote_plus(params["fanart"])
except:
        pass
try:        
        description=urllib.unquote_plus(params["description"])
except:
        pass
        
        
print str(PATH)+': '+str(VERSION)
print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)
print "IconImage: "+str(iconimage)


def setView(content, viewType):
    # set content type so library shows more views and info
    if content:
        xbmcplugin.setContent(int(sys.argv[1]), content)
    if ADDON.getSetting('auto-view')=='true':
        xbmc.executebuiltin("Container.SetViewMode(%s)" % ADDON.getSetting(viewType) )
        
        
if mode==None or url==None or len(url)<1:
        INTRO()

elif mode==2:
        BUILDMENU()
		
elif mode==5:
        APPINSTALL(name,url,description)
		
elif mode==6:
        APPSWIZARD()
		
elif mode==7:
        EMULATORWIZARD()

elif mode==8:
        EMULATORINSTALL(name,url,description)
		
elif mode==9:
        APPSWIZARD1()

elif mode==10:
        ADULTINSTALL(name,url,description)
		
elif mode==12:
        BUILDMENU1()
		
elif mode==13:
        REQUESTS()

elif mode==14:
        INTRO()		
		
elif mode==97:
        COMINGSOONLINUX()
		
elif mode==98:
        COMINGSOONWINDOWS()
		
elif mode==99:
        COMINGSOONANDROID()


        
xbmcplugin.endOfDirectory(int(sys.argv[1]))
